<!DOCTYPE html><html lang="en"><head><meta charSet="utf-8"/><meta http-equiv="X-UA-Compatible" content="IE=edge"/><title>Topology · Merge</title><meta name="viewport" content="width=device-width"/><meta name="generator" content="Docusaurus"/><meta name="description" content="&lt;p&gt;&lt;link rel=&quot;stylesheet&quot; type=&quot;text/css&quot; href=&quot;/css/api.css&quot;&gt;&lt;/p&gt;
"/><meta name="docsearch:language" content="en"/><meta property="og:title" content="Topology · Merge"/><meta property="og:type" content="website"/><meta property="og:url" content="https://mergetb.gitlab.io/index.html"/><meta property="og:description" content="&lt;p&gt;&lt;link rel=&quot;stylesheet&quot; type=&quot;text/css&quot; href=&quot;/css/api.css&quot;&gt;&lt;/p&gt;
"/><meta property="og:image" content="https://mergetb.gitlab.io/img/logo.png"/><meta name="twitter:card" content="summary"/><meta name="twitter:image" content="https://mergetb.gitlab.io/img/logo.png"/><link rel="shortcut icon" href="/img/merge.png"/><link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/dracula.min.css"/><link rel="alternate" type="application/atom+xml" href="https://mergetb.gitlab.io/blog/atom.xml" title="Merge Blog ATOM Feed"/><link rel="alternate" type="application/rss+xml" href="https://mergetb.gitlab.io/blog/feed.xml" title="Merge Blog RSS Feed"/><script type="text/javascript" src="https://buttons.github.io/buttons.js"></script><link rel="stylesheet" href="/css/main.css"/></head><body class="sideNavVisible separateOnPageNav"><div class="fixedHeaderContainer"><div class="headerWrapper wrapper"><header><a href="/"><img class="logo" src="/img/merge-light.svg" alt="Merge"/><h2 class="headerTitleWithLogo">Merge</h2></a><div class="navigationWrapper navigationSlider"><nav class="slidingNav"><ul class="nav-site nav-site-internal"><li class="siteNavGroupActive"><a href="/docs/hello-world.html" target="_self">Experimentation</a></li><li class=""><a href="/docs/site-basics.html" target="_self">Site Hosting</a></li><li class=""><a href="/docs/portal-admin.html" target="_self">Portal Hosting</a></li><li class=""><a href="/docs/tech.html" target="_self">Technology</a></li><li class=""><a href="/blog/" target="_self">News</a></li></ul></nav></div></header></div></div><div class="navPusher"><div class="docMainWrapper wrapper"><div class="container docsNavContainer" id="docsNav"><nav class="toc"><div class="toggleNav"><section class="navWrapper wrapper"><div class="navBreadcrumb wrapper"><div class="navToggle" id="navToggler"><i></i></div><h2><i>›</i><span>Reference</span></h2><div class="tocToggler" id="tocToggler"><i class="icon-toc"></i></div></div><div class="navGroups"><div class="navGroup"><h3 class="navGroupCategoryTitle">Getting Started</h3><ul><li class="navListItem"><a class="navItem" href="/docs/hello-world.html">Hello World tl;dr</a></li><li class="navListItem"><a class="navItem" href="/docs/hello-world-tutorial.html">Hello World Tutorial</a></li></ul></div><div class="navGroup"><h3 class="navGroupCategoryTitle">Examples</h3><ul><li class="navListItem"><a class="navItem" href="/docs/snowflake.html">Snowflake</a></li></ul></div><div class="navGroup"><h3 class="navGroupCategoryTitle">Reference</h3><ul><li class="navListItem"><a class="navItem" href="/docs/merge-api.html">Merge API</a></li><li class="navListItem navListItemActive"><a class="navItem" href="/docs/toporef.html">Topology</a></li><li class="navListItem"><a class="navItem" href="/docs/well-known.html">Well Known Properties</a></li><li class="navListItem"><a class="navItem" href="/docs/image-support.html">Image Support</a></li></ul></div></div></section></div><script>
            document.addEventListener('DOMContentLoaded', function() {
              createToggler('#navToggler', '#docsNav', 'docsSliderActive');
              createToggler('#tocToggler', 'body', 'tocActive');

              const headings = document.querySelector('.toc-headings');
              headings && headings.addEventListener('click', function(event) {
                if (event.target.tagName === 'A') {
                  document.body.classList.remove('tocActive');
                }
              }, false);

              function createToggler(togglerSelector, targetSelector, className) {
                var toggler = document.querySelector(togglerSelector);
                var target = document.querySelector(targetSelector);

                if (!toggler) {
                  return;
                }

                toggler.onclick = function(event) {
                  event.preventDefault();

                  target.classList.toggle(className);
                };
              }
            });
        </script></nav></div><div class="container mainContainer"><div class="wrapper"><div class="post"><header class="postHeader"><h1 class="postHeaderTitle">Topology</h1></header><article><div><span><p><link rel="stylesheet" type="text/css" href="/css/api.css"></p>
<p>Merge topologies are defined by the following objects.</p>
<h2><a class="anchor" aria-hidden="true" id="network"></a><a href="#network" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Network</h2>
<p>The network is the topo level topological object in XIR.</p>
<pre><code class="hljs css language-mypy"><span class="hljs-class"><span class="hljs-keyword">class</span> <span class="hljs-title">Network</span>:</span>
  uuid:  <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>
  nets:  <span class="hljs-type">L</span><span class="hljs-type">i</span><span class="hljs-type">s</span><span class="hljs-type">t</span>[<span class="hljs-type">N</span><span class="hljs-type">e</span><span class="hljs-type">t</span><span class="hljs-type">w</span><span class="hljs-type">o</span><span class="hljs-type">r</span><span class="hljs-type">k</span>]
  nodes: <span class="hljs-type">L</span><span class="hljs-type">i</span><span class="hljs-type">s</span><span class="hljs-type">t</span>[<span class="hljs-type">N</span><span class="hljs-type">o</span><span class="hljs-type">d</span><span class="hljs-type">e</span>]
  Links: <span class="hljs-type">L</span><span class="hljs-type">i</span><span class="hljs-type">s</span><span class="hljs-type">t</span>[<span class="hljs-type">L</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">k</span>]
  props: <span class="hljs-type">M</span><span class="hljs-type">a</span><span class="hljs-type">p</span>[<span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>,<span class="hljs-type">a</span><span class="hljs-type">n</span><span class="hljs-type">y</span>]
</code></pre>
<p>A network is basically a container for nodes, links and subnetworks. It also has a property dictionary which can hold any valid <code>JSON</code> seralizable values (including nexted objects).</p>
<h2><a class="anchor" aria-hidden="true" id="node"></a><a href="#node" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Node</h2>
<p>A node is essentially a set of properties that has endpoints. Endpoints are interconnected by <a href="#Link">links</a> to other endpoints. Nodes can contain arbitrary properties. However, there is a set of <a href="/docs/well-known.html">well known properties</a> that follow a schema. In addition to a set of properties, a node also has a configuration. Configurations define the base level sofware configuration for a node, such as the OS or firmware image.</p>
<pre><code class="hljs css language-mypy"><span class="hljs-class"><span class="hljs-keyword">class</span> <span class="hljs-title">Node</span>:</span>
  uuid:      <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>
  endpoints: <span class="hljs-type">L</span><span class="hljs-type">i</span><span class="hljs-type">s</span><span class="hljs-type">t</span>[<span class="hljs-type">E</span><span class="hljs-type">n</span><span class="hljs-type">d</span><span class="hljs-type">p</span><span class="hljs-type">o</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>]
  props:     <span class="hljs-type">M</span><span class="hljs-type">a</span><span class="hljs-type">p</span>[<span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>,<span class="hljs-type">a</span><span class="hljs-type">n</span><span class="hljs-type">y</span>]
  config:    <span class="hljs-type">M</span><span class="hljs-type">a</span><span class="hljs-type">p</span>[<span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>,<span class="hljs-type">a</span><span class="hljs-type">n</span><span class="hljs-type">y</span>]
</code></pre>
<h2><a class="anchor" aria-hidden="true" id="endpoint"></a><a href="#endpoint" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Endpoint</h2>
<p>Endpoints are the glue that bind nodes to links. They also have properties. For example, if the endpoint logically represents a network interface, it may have a capacity specification associated with it.</p>
<pre><code class="hljs css language-mypy"><span class="hljs-class"><span class="hljs-keyword">class</span> <span class="hljs-title">Endpoint</span>:</span>
  uuid:  <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>
  props: <span class="hljs-type">M</span><span class="hljs-type">a</span><span class="hljs-type">p</span>[<span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>,<span class="hljs-type">a</span><span class="hljs-type">n</span><span class="hljs-type">y</span>]
</code></pre>
<h2><a class="anchor" aria-hidden="true" id="link"></a><a href="#link" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Link</h2>
<p>Links are generalized connections. A link with only two endpoints is a point to point link. Links can have more than one endpoint indicating that they represent a hub or a switch type structure.</p>
<pre><code class="hljs css language-mypy"><span class="hljs-class"><span class="hljs-keyword">class</span> <span class="hljs-title">Link</span>:</span>
  uuid: <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>
  props: <span class="hljs-type">M</span><span class="hljs-type">a</span><span class="hljs-type">p</span>[<span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>,<span class="hljs-type">a</span><span class="hljs-type">n</span><span class="hljs-type">y</span>]
  endpoints: <span class="hljs-type">L</span><span class="hljs-type">i</span><span class="hljs-type">s</span><span class="hljs-type">t</span>[<span class="hljs-type">E</span><span class="hljs-type">n</span><span class="hljs-type">d</span><span class="hljs-type">p</span><span class="hljs-type">o</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>]
</code></pre>
<h2><a class="anchor" aria-hidden="true" id="constraints"></a><a href="#constraints" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Constraints</h2>
<p>Constraints can be applied to any node or link property. The following constraints are defined.</p>
<h3><a class="anchor" aria-hidden="true" id=""></a><a href="#" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>=</h3>
<p>The corresponding resource value must be equal to <code>@value</code>.</p>
<pre><code class="hljs css language-mypy">eq(value : <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>|<span class="hljs-type">n</span><span class="hljs-type">u</span><span class="hljs-type">m</span><span class="hljs-type">b</span><span class="hljs-type">e</span><span class="hljs-type">r</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="-1"></a><a href="#-1" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>&lt;</h3>
<p>The corresponding resource value must be less than <code>@value</code>.</p>
<pre><code class="hljs css language-mypy">lt(value : <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>|<span class="hljs-type">n</span><span class="hljs-type">u</span><span class="hljs-type">m</span><span class="hljs-type">b</span><span class="hljs-type">e</span><span class="hljs-type">r</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="-2"></a><a href="#-2" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>&lt;=</h3>
<p>The corresponding resource value must be less than or equal to <code>@value</code>.</p>
<pre><code class="hljs css language-mypy">le(value : <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>|<span class="hljs-type">n</span><span class="hljs-type">u</span><span class="hljs-type">m</span><span class="hljs-type">b</span><span class="hljs-type">e</span><span class="hljs-type">r</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="-3"></a><a href="#-3" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>&gt;</h3>
<p>The corresponding resource value must be greater than <code>@value</code>.</p>
<pre><code class="hljs css language-mypy">gt(value : <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>|<span class="hljs-type">n</span><span class="hljs-type">u</span><span class="hljs-type">m</span><span class="hljs-type">b</span><span class="hljs-type">e</span><span class="hljs-type">r</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="-4"></a><a href="#-4" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>&gt;=</h3>
<p>The corresponding resource value must be greater than or equal to <code>@value</code>.</p>
<pre><code class="hljs css language-mypy">ge(value : <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>|<span class="hljs-type">n</span><span class="hljs-type">u</span><span class="hljs-type">m</span><span class="hljs-type">b</span><span class="hljs-type">e</span><span class="hljs-type">r</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="between"></a><a href="#between" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Between</h3>
<p>The corresponding resource value must be between <code>@lower</code> and <code>@upper</code>.</p>
<pre><code class="hljs css language-mypy">between(lower : <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>|<span class="hljs-type">n</span><span class="hljs-type">u</span><span class="hljs-type">m</span><span class="hljs-type">b</span><span class="hljs-type">e</span><span class="hljs-type">r</span>, upper : <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>|<span class="hljs-type">n</span><span class="hljs-type">u</span><span class="hljs-type">m</span><span class="hljs-type">b</span><span class="hljs-type">e</span><span class="hljs-type">r</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="ordered-choice"></a><a href="#ordered-choice" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Ordered Choice</h3>
<p>The corresponding value must match some element in <code>@value</code>, the first match found is used.</p>
<pre><code class="hljs css language-mypy">choice(value : <span class="hljs-type">L</span><span class="hljs-type">i</span><span class="hljs-type">s</span><span class="hljs-type">t</span>[<span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>|<span class="hljs-type">n</span><span class="hljs-type">u</span><span class="hljs-type">m</span><span class="hljs-type">b</span><span class="hljs-type">e</span><span class="hljs-type">r</span>])
</code></pre>
<h2><a class="anchor" aria-hidden="true" id="units"></a><a href="#units" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Units</h2>
<p>Unit transformations can be assigned to values in XIR topologies through the following functions.</p>
<h3><a class="anchor" aria-hidden="true" id="bandwidth"></a><a href="#bandwidth" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Bandwidth</h3>
<pre><code class="hljs css language-mypy">bps(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
kbps(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
mbps(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
gbps(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
tbps(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
pbps(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
ebps(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="memory"></a><a href="#memory" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Memory</h3>
<pre><code class="hljs css language-mypy">B(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
kB(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
mB(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
gB(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
tB(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
pB(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
eB(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="frequency"></a><a href="#frequency" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Frequency</h3>
<pre><code class="hljs css language-mypy">Hz(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
KHz(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
MHz(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
GHz(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
THz(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="time"></a><a href="#time" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Time</h3>
<pre><code class="hljs css language-mypy">ns(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
us(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
ms(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
s(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="percent"></a><a href="#percent" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Percent</h3>
<pre><code class="hljs css language-mypy">percent(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="memory-transfer"></a><a href="#memory-transfer" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Memory Transfer</h3>
<pre><code class="hljs css language-mypy">mt(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
gt(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
tt(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="power"></a><a href="#power" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Power</h3>
<pre><code class="hljs css language-mypy">w(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
kw(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
mw(value : <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>)
</code></pre>
</span></div></article></div><div class="docs-prevnext"><a class="docs-prev button" href="/docs/merge-api.html"><span class="arrow-prev">← </span><span>Merge API</span></a><a class="docs-next button" href="/docs/well-known.html"><span>Well Known Properties</span><span class="arrow-next"> →</span></a></div></div></div><nav class="onPageNav"><ul class="toc-headings"><li><a href="#network">Network</a></li><li><a href="#node">Node</a></li><li><a href="#endpoint">Endpoint</a></li><li><a href="#link">Link</a></li><li><a href="#constraints">Constraints</a><ul class="toc-headings"><li><a href="#">=</a></li><li><a href="#-1">&lt;</a></li><li><a href="#-2">&lt;=</a></li><li><a href="#-3">&gt;</a></li><li><a href="#-4">&gt;=</a></li><li><a href="#between">Between</a></li><li><a href="#ordered-choice">Ordered Choice</a></li></ul></li><li><a href="#units">Units</a><ul class="toc-headings"><li><a href="#bandwidth">Bandwidth</a></li><li><a href="#memory">Memory</a></li><li><a href="#frequency">Frequency</a></li><li><a href="#time">Time</a></li><li><a href="#percent">Percent</a></li><li><a href="#memory-transfer">Memory Transfer</a></li><li><a href="#power">Power</a></li></ul></li></ul></nav></div><footer class="nav-footer" id="footer"><section class="sitemap"><a href="/" class="nav-home"><img src="/img/merge-light.svg" alt="Merge" width="66" height="58"/></a><div><h5>Docs</h5><a href="/docs/en/hello-world.html">Experimentation</a><a href="/docs/en/site-basics.html">Site Hosting</a><a href="/docs/en/portal-admin.html">Portal Hosting</a></div><div><h5>Community</h5><a href="/en/users.html">User Showcase</a><a href="https://mergetb.slack.com/">Project Chat</a></div><div><h5>More</h5><a href="/blog">Blog</a><a href="https://gitlab.com/mergetb">GitLab</a></div></section><section class="copyright">Copyright © 2018 Information Sciences Institute</section></footer></div></body></html>